//+------------------------------------------------------------------+
//|                Gann_HiLo activater bars on jurik_mtf+alerts.mq4 |
//|                                                           mladen |
//|                                                                  |
//| Original introduced by Robert Krausz                             |
//| (February 1998, Stocks & Commodities Magazine                    |
//+------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1  DodgerBlue
#property indicator_color2  Sienna
#property indicator_width1  2
#property indicator_width2  2

//
//
//
//
//
//
//
//
//
//

extern string TimeFrame       = "Current time frame";
extern int    Length          = 15;
extern double Phase           = 0;
extern bool   Double          = false;

extern bool   alertsOn        = false;
extern bool   alertsOnCurrent = false;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = false;
extern bool   alertsEmail     = false;

extern bool   verticalLinesVisible     = true;
extern string LineIdentifier           = "Gann-HL-jk-lines";
extern color  verticalLinesUpColor     = LawnGreen; //DeepSkyBlue;
extern color  verticalLinesDownColor   = PaleVioletRed;
extern int    verticalLinesStyle       = STYLE_DOT;
extern int    verticalLinesWidth       = 0;//
//
//
//
//

double hi[];
double lo[];
double Hlv[];

//
//
//
//
//

string indicatorFileName;
bool   calculateValue;
bool   returnBars;
int    timeFrame;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
 IndicatorBuffers(3);
   SetIndexBuffer(0,hi); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,lo); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,Hlv);
   SetIndexLabel(0,NULL);
   SetIndexLabel(1,NULL);
   SetIndexLabel(2,"b2-GannHLjurik,b2-Trd");
   
     //
     //
     //
     //
     //
      
     indicatorFileName = WindowExpertName();
     calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
     returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
     timeFrame         = stringToTimeFrame(TimeFrame);
      
     //
     //
     //
     //
     //
   
   IndicatorShortName(timeFrameToString(timeFrame)+" RK-ml-Gann_ HiLo activator bars jurik");
 return(0);
}

//
//
//
//
//

int deinit(){ 

   if(!calculateValue && verticalLinesVisible) deleteLines();

 return(0); }

//
//
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit = MathMin(Bars - counted_bars,Bars-1);
           if (returnBars)  { hi[0] = limit+1; return(0); }
   
   //
   //
   //
   //
   //
   
   if (calculateValue || timeFrame == Period())
   {

     for(i=limit;i>=0;i--)
     {
       
        Hlv[i] = Hlv[i+1];
         if(Close[i] > iDSmooth(iMA(Symbol(),0,1,0,MODE_SMA,PRICE_HIGH,i+1),Length,Phase,Double,i+1, 0)) Hlv[i] =  1;
         if(Close[i] < iDSmooth(iMA(Symbol(),0,1,0,MODE_SMA,PRICE_LOW, i+1),Length,Phase,Double,i+1,20)) Hlv[i] = -1;
         Print("line 148                      Hlv[i] "+Hlv[i]+"   Hlv[i+1] "+Hlv[i+1]);
         if(Hlv[i] == -1)
              { lo[i] = High[i]; hi[i] = Low[i]; }
         else { hi[i] = High[i]; lo[i] = Low[i]; }
         Print("line 152                      Hlv[i] "+Hlv[i]+"   Hlv[i+1] "+Hlv[i+1]);
         manageLines(i);
   }
   manageAlerts();
   return(0);
   }
   
   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for(i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         hi[i]  = EMPTY_VALUE;
         lo[i]  = EMPTY_VALUE;
         Hlv[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Length,Phase,Double,2,y); 
         
         if(Hlv[i] == -1)
              { lo[i] = High[i]; hi[i] = Low[i]; }
         else { hi[i] = High[i]; lo[i] = Low[i]; }
         Print("line 178                      Hlv[i] "+Hlv[i]+"   Hlv[i+1] "+Hlv[i+1]);
         manageLines(i); 
   }
   manageAlerts();
   return(0);
   }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

string sTfTable[] = {"M1","M5","M10","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,10,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

double wrk[][40];

#define bsmax  5
#define bsmin  6
#define volty  7
#define vsum   8
#define avolty 9

//
//
//
//
//

double iDSmooth(double price, double length, double phase, bool isDouble, int i, int s=0)
{
   if (isDouble)
         return (iSmooth(iSmooth(price,MathSqrt(length),phase,i,s),MathSqrt(length),phase,i,s+10));
   else  return (iSmooth(price,length,phase,i,s));
}

//
//
//
//
//

double iSmooth(double price, double length, double phase, int i, int s=0)
{
   if (length <=1) return(price);
   if (ArrayRange(wrk,0) != Bars) ArrayResize(wrk,Bars);
   
   int r = Bars-i-1; 
      if (r==0) { for(int k=0; k<7; k++) wrk[r][k+s]=price; for(; k<10; k++) wrk[r][k+s]=0; return(price); }

   //
   //
   //
   //
   //
   
      double len1   = MathMax(MathLog(MathSqrt(0.5*(length-1)))/MathLog(2.0)+2.0,0);
      double pow1   = MathMax(len1-2.0,0.5);
      double del1   = price - wrk[r-1][bsmax+s];
      double del2   = price - wrk[r-1][bsmin+s];
      double div    = 1.0/(10.0+10.0*(MathMin(MathMax(length-10,0),100))/100);
      int    forBar = MathMin(r,10);
	
         wrk[r][volty+s] = 0;
               if(MathAbs(del1) > MathAbs(del2)) wrk[r][volty+s] = MathAbs(del1); 
               if(MathAbs(del1) < MathAbs(del2)) wrk[r][volty+s] = MathAbs(del2); 
         wrk[r][vsum+s] =	wrk[r-1][vsum+s] + (wrk[r][volty+s]-wrk[r-forBar][volty+s])*div;
         
         //
         //
         //
         //
         //
   
         wrk[r][avolty+s] = wrk[r-1][avolty+s]+(2.0/(MathMax(4.0*length,30)+1.0))*(wrk[r][vsum+s]-wrk[r-1][avolty+s]);
            if (wrk[r][avolty+s] > 0)
               double dVolty = wrk[r][volty+s]/wrk[r][avolty+s]; else dVolty = 0;   
	               if (dVolty > MathPow(len1,1.0/pow1)) dVolty = MathPow(len1,1.0/pow1);
                  if (dVolty < 1)                      dVolty = 1.0;

      //
      //
      //
      //
      //
	        
   	double pow2 = MathPow(dVolty, pow1);
      double len2 = MathSqrt(0.5*(length-1))*len1;
      double Kv   = MathPow(len2/(len2+1), MathSqrt(pow2));

         if (del1 > 0) wrk[r][bsmax+s] = price; else wrk[r][bsmax+s] = price - Kv*del1;
         if (del2 < 0) wrk[r][bsmin+s] = price; else wrk[r][bsmin+s] = price - Kv*del2;
	
   //
   //
   //
   //
   //
      
      double R     = MathMax(MathMin(phase,100),-100)/100.0 + 1.5;
      double beta  = 0.45*(length-1)/(0.45*(length-1)+2);
      double alpha = MathPow(beta,pow2);

         wrk[r][0+s] = price + alpha*(wrk[r-1][0+s]-price);
         wrk[r][1+s] = (price - wrk[r][0+s])*(1-beta) + beta*wrk[r-1][1+s];
         wrk[r][2+s] = (wrk[r][0+s] + R*wrk[r][1+s]);
         wrk[r][3+s] = (wrk[r][2+s] - wrk[r-1][4+s])*MathPow((1-alpha),2) + MathPow(alpha,2)*wrk[r-1][3+s];
         wrk[r][4+s] = (wrk[r-1][4+s] + wrk[r][3+s]); 

   //
   //
   //
   //
   //

   return(wrk[r][4+s]);
}

//
//
//
//
//

void manageAlerts()
{
   if (!calculateValue && alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));
      if (Hlv[whichBar] != Hlv[whichBar+1])
      {
         if (Hlv[whichBar] == 1) doAlert(whichBar,"buy");
         if (Hlv[whichBar] ==-1) doAlert(whichBar,"sell");
      }         
   }
}   

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," - ",timeFrameToString(timeFrame)+" Gann HiLo  ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Gann HiLo "),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}

//
//
//
//
//

//+-------------------------------------------------------------------
//| Rk Added Feb 23, 2015                                                                  
//+-------------------------------------------------------------------

void manageLines(int i)
{
   if (!calculateValue && verticalLinesVisible)
   {
         deleteLines(Time[i]);
          Print("in MangeLines line 414              Hlv[i] "+Hlv[i]+"   Hlv[i+1] "+Hlv[i+1]);
         if (Hlv[i]!=Hlv[i+1])
         {
            if (Hlv[i+1] == -1 && Hlv[i] !=-1) drawLines(i,verticalLinesUpColor);
            if (Hlv[i+1] ==  1 && Hlv[i] != 1) drawLines(i,verticalLinesDownColor);
         }
   }
}               

//
//
//
//
//

void drawLines(int i,color theColor)
{
    string name = LineIdentifier+":"+Time[i];
   
      //
      //
      //
      //
      //
      
      ObjectCreate(name,OBJ_VLINE,0,Time[i],0);
         ObjectSet(name,OBJPROP_COLOR,theColor);
         ObjectSet(name,OBJPROP_STYLE,verticalLinesStyle);
         ObjectSet(name,OBJPROP_WIDTH,verticalLinesWidth);
         ObjectSet(name,OBJPROP_BACK,true);
}

//
//
//
//
//
void deleteLines()
{
   string lookFor       = LineIdentifier+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
}
void deleteLines(datetime time)
{
   string lookFor = LineIdentifier+":"+time; ObjectDelete(lookFor);
}



